<?php
/**
 * @package Include/help/ja
 */
?> 

<h1> アラートテンプレートの作成</h1>

アラートテンプレートを作成するための最初のステップは、状態の設定です。
<br><br>
状態の設定で入力するフィールドの詳細は次の通りです。
<br><br>
<ul type=”disc”>
<li>    <b>名前(Name):</b> テンプレートの名前です。<br></li><br>
<li>    <b>説明(Description):</b> テンプレートの機能を説明するもので、アラート表示においてテンプレートを特定するのに便利です。<br></li><br>
<li>    <b>優先度(Priority):</b> アラートに関する情報を設定するフィールドです。アラートを検索するのに便利です。次の優先度の中から選択できます。<br><br></li><br>
* メンテナンス(Maintenance)<br>
* 情報(Informational)<br>
* 正常(Normal)<br>
* マイナー(Minor)<br>
* 警告(Warning)<br>
* メジャー(Major)<br>
* 障害(Critical)<br>
* 警告/障害(Warning/Critical)<br>
* 非正常(Not normal)<br><br>

<li>    <b>状態タイプ(Condition Type):</b> アラートに適用する状態の種類を設定するフィールドです。選択した種類に関連したメニューが追加されます。次のフィールドがあります。<br></li></ul>
<li>    <i>正規表現(Regular Expression):</i> 正規表現を設定します。モジュールの値が正規表現にマッチしたときに、アラートが発生します。文字列データにマッチしてアラートを発生させるのに使います。他の条件は、ステータスや数値データのためのものです。<br> 
正規表現を選択すると、値がマッチした時の対応を指定するチェックボックスが現れます。選択すると、値がマッチしたときにアラートが発生します。選択しない場合は、値がマッチしないときにアラートが発生します。
</li><br>
<li>    <i>最大および最小(Max and Min):</i> サービスが警告状態となる制限値です。<br>
正規表現を選択すると、値がマッチした時の対応を指定するチェックボックスが現れます。選択した場合は、値が最大と最少の間の範囲を外れた場合にアラートが発生します。選択しないと、値が最大と最小の間に入った場合にアラートが発生します。
</li><br>
<li>    <i>最大(Max):</i> 最大値です。<br></li><br>
<li>    <i>最小(Min):</i> 最小値です。モジュールの値が設定した最小値より小さくなるとアラートが発生します。</li><br>
<li>    <i>同じ値(Equal to):</i> 同じ値です。モジュールの値が設定した値と同じ場合にアラートが発生します。数値データ(例えば 0 や 0.124 など)のみ適用できます。</li><br>
<li>    <i>異なる値(Not Equal to):</i> 上記と似ていますが、異なる場合です。</li><br>
<li>    <i>警告状態(Warning Status):</i> モジュールの状態です。状態が警告状態にになったときにアラートが発生します。</li><br>
<li>    <i>障害状態(Critical Status):</i> モジュールの状態です。状態が障害状態になったときにアラートが発生します。</li><br>
<li>    <i>不明状態(Unknown Status):</i> モジュールが不明状態になったときにアラートが発生します。</li><br>
<li>    <i>変化発生(On Change)</i> モジュールの値が変化したときにアラートが発生します。</li><br>
<li>    <i>常時(Always)</i> 常にアラートが発生します。</li><br>
<br><br>

入力が完了したら、"次" ボタンをクリックし、次の画面に行きます。

<?php html_print_image ("images/help/alert1.png", false, array('width' => '550px')); ?>
<br><br>
次に、入力するフィールドの詳細を説明します。
<br><br>

<b>曜日(Days of Week)</b><br><br>

アラートを発生させる曜日です。<br><br>

<b>特別日リストの利用(Use special days list)</b><br><br>

特別日(休日や特別な出勤日)リストを利用するかどうかを選択します。<br><br>

<b>開始時間(Time From)</b><br><br>

アラートのアクションを実行開始する時間です。<br>
<br>
<b>終了時間(Time To)</b><br><br>

アラートのアクション実行を終了する時間です。<br><br>

<b>再通知間隔(Time Threshold)</b><br><br>

最大アラート数を越えてアラートを発報しないことを保証する時間間隔です。指定した間隔を越えてもなお、値が復旧していない場合は、アラートが発報します。値が復旧した場合は、再通知間隔を待たずにリカバーします。<br><br>

<b>最小アラート数(Min number of alerts)</b><br><br>

データが何回閾値を越えた時にアラートを発報し始めるかの回数(モジュールで設定する連続抑制回数を越えた後からのカウント)です。デフォルトは 0 で、初回の閾値越えでアラートが発報することを意味します。数回の障害検知を除外する必要がある場合のフィルタとして使います。<br><br>

<b>最大アラート数(Max number of alerts)</b><br><br>

再通知間隔内に連続して送信する最大アラートの数です。<br><br>

<b>拡張フィールド管理(Advanced fields management)</b><br><br>

"_fieldX_" に値を定義します。これらはマクロのリストで使われます。詳細はフィールドのヘルプを参照してください。<br><br>

<b>通常のアクション(Default Action)</b><br><br>

テンプレートがデフォルトで持つアクションをメニューから選択します。テンプレートをモジュールに割り当てた時、このアクションが自動的に設定されます。"なし"か、いずれか一つを選択することができますが、デフォルトとしては複数のアクションは選択できません。

<?php html_print_image ("images/help/alert2.png", false, array('width' => '550px')); ?>

次の入力フィールは以下の通りです。<br><br>

<b>復旧通知(Alert Recovery)</b><br><br>

メニューから、アラートの復旧通知をするかどうかを選択できます。有効にした場合、モジュールの値が正常値に戻った時に、アラートのフィールド1で定義したアラートが、以降のフィールド2,3の定義を使って実行されます。<br><br>

<b>フィールド2(Field 2)</b><br><br>

復旧通知における "_field2_" の値を定義します。<br><br>

<b>フィールド3(Field 3)</b><br><br>

復旧通知における "_field3_" の値を定義します。<br>

フィールドを入力したら、"終了"ボタンをクリックします。
