<?php
/**
 * @package Include/help/ja
 */
?>
<h1>障害状態</h1>

<h2>数値タイプモジュール</h2>

<p>
このフィールドは、最小と最大、条件の反転の 3つの値があります。これらを正しく設定すると、モジュールが指定した値になった時に障害状態にすることができます。
</p>

<p>
これを理解するために例を見てみましょう。エージェントにおける CPU モジュールは、
常に緑(正常)になっています。なぜなら、単純に 0% から 100% の間の情報を返している
だけだからです。CPU 使用率のモジュールで、使用率が 90% になった時に赤(障害状態
)にしたい場合は、次のように設定します。
</p>
</p>

<li>障害 最小値:90</li>
<li>障害 最大値:0 (制限なし)</li>

<p>
これにより、値が 90 以上になると、表示が赤(障害状態)になり、90を下回ると緑
(正常状態)になります。
</p>

<p>
条件の反転をチェックすると、設定した範囲外になったときにモジュールが障害状態になります。この場合であれば、90を下回った場合になります。
</p>

<h2>文字列タイプモジュール</h2>

<p>
文字列および条件の反転の 2つのフィールドがあります。値を正しく設定することにより、モジュールが障害状態になります。
</p>

<p>
文字列フィールドは、正規表現で設定します。データがそれにマッチすると、モジュールが障害状態になります。
</p>

<li>文字列:(urgent|serious)</li>

<p>
この場合、モジュールの値に urgent または serious が含まれている場合に障害状態となります。
</p>

<p>
条件の反転をチェックすると、正規表現にマッチしない場合にモジュールが障害状態になります。
</p>
