<?php
/**
 * @package Include/help/ja
 */
?>
<h1>プラグイン登録</h1>

他のコンポーネントとは異なり、デフォルトでは Pandora FMS にあらかじめ設定されたコンポーネントが存在しません。そのため、エージェントのモジュールに追加できるよ、作成する必要があります。Pandora FMS のインストールディレクトリにはいくつかのプラグインが含まれていますが、前述の通りデータベースに設定はされていません。
<br><br>
Pandora FMS にすでに存在するプラグインを追加するには、コンソールの管理メニューで、サーバ管理をクリックします。その後、プラグイン管理をクリックします。
<br><br>
プラグイン管理画面に行ったら、追加ボタンをクリックします。それ以外のメニューはありません。
<br><br>
次のように、プラグイン作成のフォームを入力します。
<?php html_print_image ("images/help/plugin1.png", false, array('width' => '550px')); ?>
<br><br>
<b>名前(Name)</b><br>
プラグイン名です。ここでは、Nmap です。
<br><br>
<b>プラグインタイプ(Plugin type)</b><br>
プラグインは、標準と Nagios の 2種類があります。標準プラグインは、処理を実行し値を取得するものです。Nagios プラグインは、その名の通り Pandora FMS で Nagios プラグインを利用できるようにするものです。Nagios プラグインの主な違いは、実行結果の成功・失敗を戻値で返すことです。
<br><br>
Nagios プラグインを利用して正常・異常の状態ではなくデータを取得したい場合は、Nagios プラグインを "標準" モードで利用します。
<br><br>
ここでの例(NMAPを実行するプラグイン)では、標準を選択します。
<br><br>
<b>最大タイムアウト(Max. timeout)</b><br>

プラグインの有効期間です。この時間内に応答を得られなかった場合、モジュールは不明状態となり、値は更新されません。これは、プラグインを使って監視を実装する場合にとても重要な要素です。この時間を越えてプラグインの実行に時間がかかるような場合は、実行結果を得ることができません。プラグインを実行して結果を得られるまでにかかる時間よりも常に大きい値にする必要があります。特に指定しない場合は、設定ファイルの plugin_timeout の値が利用されます。
<br><br>
この例では、15を設定しています。
<br><br>
<b>説明(Description)</b><br>

プラグインの説明です。例えば、"Test # UDP open ports" といった簡単な説明を書きます。可能であれば、プラグインがどんなパラメータを受け付けるのか後でわかりやすいように、パラメータの説明を書くと良いでしょう。
<br><br>
<b>プラグインコマンド(Plug-in command)</b><br>

プラグインコマンドのパスを設定します。デフォルトのディレクトリは、標準のインストールをした場合、/usr/share/pandora_server/util/plugin/ です。システム上の任意のパスを指定することができます。この例では、/usr/share/pandora_server/util/plugin/udp_nmap_plugin.shin を設定しています。
<br><br>
Pandora サーバは、このスクリプトを実行します。このファイルは、アクセスし実行できるパーミッションになっている必要があります。
<br><br>
<b>プラグインパラメータ(Plug-in parameters)</b><br>

コマンドにスペースをあけて付けられるパラメータ文字列です。このパラメータフィールドでは、_filed1_ _filed2_ ... _filedN_ といったマクロを利用できます。
<br><br>
<b>パラメータマクロ(Parameters macros)</b><br>

プラグインパラメータフィールドで利用するマクロを無制限で追加できます。このマクロは、モジュール設定内に通常のテキストフィールドとして表示されます。
<br><br>
それぞれのマクロには 3つのフィールドがあります。
<br><br>
    <i>説明(Description):</i> マクロの簡単な説明です。フィールドのラベルになります。<br>
    <i>デフォルト値(Default value):</i> フィールドのデフォルト値です。<br>
    <i>ヘルプ(Help):</i> マクロの説明テキストです。<br>
<br><br>
マクロ設定例:
<br><br>
<?php html_print_image ("images/help/plugin2.png", false, array('width' => '550px')); ?>
<br><br>
モジュールの編集画面におけるこのマクロの例:
<br><br>
<?php html_print_image ("images/help/plugin3.png", false, array('width' => '550px')); ?>
