<?php
/**
 * @package Include/help/ja
 */
?>
<h1>自動検出タスク</h1>

ネットワークの自動検出タスクを編集したり新たに作成する場合は、タスクが正しく処理されるよう必要なフィールドに入力する必要があります。<br><br>


<b>タスク名(Task name)</b><br>

検出タスクの名前です。フィルターやテンプレートとは異なり、タスクを区別しやすい説明を入れるだけです。<br><br>

<b>自動検出サーバ(Recon server)</b><br>

タスクを割り当てる自動検出サーバです。複数の自動検出サーバがある場合は、自動検出タスクをどのサーバで実行するかを選択します。<br><br>

<b>モード(Mode)</b><br>

"ネットワークスキャン9Network Scanning)" および "スクリプトカスタム(Script Custom)" のいずれかのタスクモードを選択します。前者のモードは、従来からのネットワークの検出タスクで、後者はカスタムスクリプトによるタスクです。<br><br>

<b>ネットワーク(Network)</b><br>

検出したいネットワークです。ネットワークを / でマスクを指定する <b>CIDR</b> 表記を使います。例えば、192.168.1.0/24 は、192.168.1.0 から 192.168.1.255 までのクラス C のネットワークです。<br><br>

<b>間隔(Interval)</b>
<br>
検出処理の間隔です。自動検出処理では、ネットワーク上にそれぞれの IP アドレスに対して ping を送信するため、短い間隔は設定しないでください。自動検出対象ネットワークが非常に大きく(例えばクラスAのネットワーク)、間隔が短い(6時間)と、Pandora FMS はネットワークに大量の ping を投げ続け、ネットワークおよび Pandora FMS が高負荷になります。<br><br>

<b>モジュールテンプレート(Module template)</b><br>

検出システムに追加するプラグインテンプレートです。検出タスクの対象(OSやポート)にマッチするシステムを検出した場合、プラグインテンプレートに定義されたモジュールが登録されます。<br><br>

<b>OS</b><br>

認識するオペレーティングシステムです。任意(Any)の OS ではなく特定の OS を選択した場合、該当の OS のシステムのみ追加されます。静的なパラメータを元に実施されるため、(ネットワークがフィルタリングされている、セキュリティソフトウエアが導入されている、システムのバージョンが編集されているなど)特定の条件下では、システム検出時に Pandora FMS が誤認識する可能性があることに注意してください。この機能を利用するには、Xprobe2 がインストールされている必要があります。<br><br>

<b>ポート(Ports)</b><br>

特定のポート番号またはその範囲を指定します。例えば、22,23,21,80-90,443,8080 など。このフィールドを利用した場合は、指定したポートが開いていることを検出したサーバのみがシステムに追加されます。ホストが検出されても、該当ポートが一つも開いていない場合は、無視されます。これは、OS の種類によるフィルタと合わせて、必要なもののみを検出するのに利用できます。例えば、ポート 23 と 57 が開いていて、"BSD" と認識したら、ルータであるなど。<br><br>

<b>グループ(Group)</b><br>

検出したシステムを追加するグループです。新規のシステムには一つのグループを割り当てる必要があります。未分類のエージェントのグループがあるのであれば、ここではそれを選んでおくのも良いでしょう。<br><br>

<b>インシデント(Incident)</b><br>

新たなシステムを検出したときに、インシデントを発行するかどうかを示します。タスクにより、一つのインシデントが作成されます。検出した対象ごとに一つのインシデントではなく、検出した新たなシステムすべてをまとめて一つです。また、上記で定義したグループ内に自動作成されます。<br><br>

<b>SNMPデフォルトコミュニティ<SNMP Default community)</b><br>

機器の検出に利用するデフォルトの SNMP コミュニティです。<br><br>

<b>コメント(Comments)</b><br>

ネットワーク検出タスクに関するコメントです。<br><br>

<b>OS検出(OS detection)</b><br>

このオプションを選択すると、OS の検出が行われます。<br><br>

<b>名前解決(Name resolution)</b><br>

このオプションを選択すると、エージェントは IP アドレスではなく、設定されていればホスト名で登録されます。<br><br>

<b>親の検出(Parent detection)</b><br>

このオプションを選択すると、コンピュータが他に接続されており、その子として作成するかどうかを検出します。<br><br>

<b>親の再帰(Parent recursion)</b><br>

検出後にエージェントの親子関係を見る最大の再帰回数を示します。<br><br>
