<?php
/**
 * @package Include/help/ja
 */
?>

<h1> 新たなサービスの作成</h1>

サービスは、複数のエージェントのモジュールを関連付けし、モジュールの値をリアルタイムで計算して表現するものです。まず最初に、サービスとして必要なすべてのデバイスを監視し、モジュールの状態が正常、警告、障害のいずれかになっている必要があります。
<br><br>
すべてのデバイスの監視設定をしたら、サービスのグループを作成することができます。それぞれのサービス内では、サービス監視に必要なモジュールを追加することができます。たとえば、オンラインショップのサービスを監視したい場合、コンテンツや通信状態などを監視するモジュールが必要です。

<br><br>

新たなサービスを作成するには、「作成」ボタンをクリックします。
<br><br>

<?php html_print_image ("images/help/service2.png", false, array('width' => '550px')); ?>
<br><br>
この時点では、アイテムが無い状態でサービスが作成されています。そのため、サービスにアイテムを追加する必要があります。新たなアイテムを追加するには、右上のサービス管理タブのオレンジ色のツールアイコンをクリックし、作成をクリックします。すると、以下のようなフォームが表示されます。このフォームでは、追加したいエージェントのモジュールを選択します。また、サービスにおける、そのモジュールの正常、警告、障害状態に対するウエイトを入力します。サービス内で重要なモジュールほどウエイトは大きくします。
<br><br>

<?php html_print_image ("images/help/service1.png", false, array('width' => '550px')); ?>
<br><br>
全てのフィールドに入力し作成ボタンをクリックすると、処理が実行されたメッセージと共に次のような画面が表示されます。
<br><br>
<?php html_print_image ("images/help/service3.png", false, array('width' => '550px')); ?>
<br><br>
サービスを監視するために必要な全てのアイテムを追加できます。例えば、このサービスに適切な重みを持たせた要素を追加すると、次のようになります。
<br><br>
<?php html_print_image ("images/help/service4.png", false, array('width' => '550px')); ?>
<br><br>
すると、下に示すようなサービス一覧が表示されます。画面にはリアルタイムで計算された値が表示され、表示されるパラメータは次の通りです。
<br><br>
<ul type=”disc”>
<li>    <i>名前(Name):</i> サービス名。<br></li>
<li>    <i>説明(Description):</i> サービスの説明。<br></li>
<li>    <i>グループ(Group):</i> サービスが属しているグループ。<br></li>
<li>    <i>障害(Critical):</i> サービスが障害状態になる閾値。<br></li>
<li>    <i>警告(Warning):</i> サービスが警告状態になる閾値。<br></li>
<li>    <i>値(Value):</i> サービスの値。リアルタイムで計算されます。<br></li>
<li>    <i>状態(Status):</i> 値および障害・警告の閾値に応じたサービスの状態。<br></li>
</ul>
<br><br>
<?php html_print_image ("images/help/service5.png", false, array('width' => '550px')); ?>
<br><br>
サービス名をクリックするとサービスビューが表示されます。前述の通り、サービスの値は、それぞれのモジュールの状態に関連した重み付け(ウエイト)を計算したものです。モジュールと同様に、サービスの状態はその値に依存しています。この画面では、それぞれのサービスアイテムの状態を次のパラメータと共に表示します。
<br><br>
<ol>
<li />    <i>エージェント名(AgentName):</i> モジュールが属するエージェント名。<br>
<li />    <i>モジュール名(Module Name):</i> モジュール名.<br>
<li />    <i>説明(Description):</i> 任意の説明。<br>
<li />    <i>障害ウエイト(Weight Critical):</i> モジュールが障害状態の場合のウエイト。<br>
<li />    <i>警告ウエイト(Weight Warning):</i> モジュールが警告状態の場合のウエイト。<br>
<li />    <i>正常ウエイト(Weight Ok):</i> モジュールが正常状態の場合のウエイト。<br>
<li />    <i>データ(Data):</i> モジュールの値。<br>
<li />    <i>状態(Status):</i> モジュールの状態。<br>
</ol>

<br><br>
<?php html_print_image ("images/help/service6.png", false, array('width' => '550px')); ?>
<br><br>
サービスに関連付けするモジュールを作成することも可能です。これには、定期的な状態計算、アラートシステムの統合などの利点があります。モジュールをサービスに関連付けるには、次の手順を実施します。
<br><br>
<ol>
<li />    サービスを構成する監視を設定し、それがうまく機能していることを確認します。<br><br>
<li />    それぞれの監視項目で、障害や警告状態に対する閾値を設定します。<br><br>
<li />    必要な監視項目でサービスを作成し、サービスに含まれるそれぞれの監視項目の重み付け、サービスの閾値を設定します。<br><br>
<li />    サービスに関連付けた監視を置きたいエージェントへ行きます。<br><br>
<li />    エージェントに "予測サーバ" のモジュールを作成し、予測サーバのモジュール編集にて、サービスの一つを割り当てます。<br><br>
<li />    サービスにアラートを割り当てたい場合は、サーバに設定されたモジュール一覧から行います。サーバには、アラート、グラフ、レポートを追加することはできません。前述の通り、これらはすべてサービスに関連づけたモジュールで行う必要があります。
<br><br>
</ol>
<br><br>
<?php html_print_image ("images/help/service7.png", false, array('width' => '550px')); ?>
<br><br>
